/// <reference types="express" />
import { Repository, SelectQueryBuilder } from "typeorm";
import { Request } from "express";
export declare class Element {
    _class: string;
    text: string;
}
export declare class TableConfiguration {
    _class: string;
    header: Element[];
    data: Element[][];
    addClass(_class: string): TableConfiguration;
    addHeader(text: string, _class?: string): TableConfiguration;
    addData(texts: string[], _classes?: string[]): TableConfiguration;
}
export declare class PaginationConfiguration {
    total: number;
    pageSize: number;
    pageCount: number;
    currentPage: number;
    left: number;
    right: number;
    maxPages: number;
    _class: string;
    calculate(): void;
    addClass(_class: string): PaginationConfiguration;
}
export declare class DatatableConfiguration {
    private table;
    private repository;
    private req;
    private urlNoPage;
    private urlNoOrder;
    private map;
    private _classes;
    private mapTransformers;
    private pagination;
    constructor(repository: Repository<any>, req: Request);
    addTableClass(_class: string): DatatableConfiguration;
    addTableHeader(text: string, _class?: string): DatatableConfiguration;
    addDataMap(map: string[], _classes?: string[]): DatatableConfiguration;
    addDataTransformer(label: string, exe: (value: any, entity: any) => any): DatatableConfiguration;
    addPaginationClass(_class: string): DatatableConfiguration;
    private setupPageRequested();
    private getQueryValue(key);
    private addOrderBy(query);
    private addFilterBy(query);
    fetchData(query?: SelectQueryBuilder<any>): Promise<void>;
}
