/// <reference types="multer" />
import BaseEntity from "./base.entity";
import User from "./user.entity";
export default class Media extends BaseEntity {
    hiddenFields: string[];
    id: number;
    originalName: string;
    slug: string;
    private is_directory;
    isDirectory: boolean;
    mimetype: string;
    size: number;
    fileName: string;
    path: string;
    parent: Media;
    _children: Media[];
    owner: User;
    readonly children: Promise<Media[]>;
    remove(): Promise<this>;
    static persist(uploadMedia: Express.Multer.File, user: User, directory?: Media): Promise<Media>;
    static mkdir(name: string, user?: User, directory?: Media | null): Promise<Media>;
    static getFolder(path: string): Promise<Media | undefined>;
    static findBySlug(slug: string): Promise<Media | undefined>;
    static findBySlugOrId(key: string): Promise<Media | undefined>;
}
