"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var response_1 = require("./response");
var sharp = require("sharp");
/**
 * Generation of a File response.
 */
var FileResponse = /** @class */ (function (_super) {
    __extends(FileResponse, _super);
    function FileResponse(path) {
        var _this = _super.call(this) || this;
        _this.path = path;
        return _this;
    }
    Object.defineProperty(FileResponse.prototype, "contentType", {
        /**
         * Set the content type of the response.
         * @param value the content type
         */
        set: function (value) {
            this._contentType = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileResponse.prototype, "options", {
        /**
         * Set the file options, to correctly generate the response.
         * @param value the FileOptions
         */
        set: function (value) {
            this._options = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Generation of the response.
     * This method can eventually perform some transformation on output if a
     * FileOptions was specified.
     */
    FileResponse.prototype.performResponse = function (_, res) {
        if (this._contentType) {
            res.contentType(this._contentType);
        }
        if (this._options) {
            if (!this._options.height) {
                sharp(this.path)
                    .resize(this._options.width)
                    .toBuffer()
                    .then(function (buff) {
                    res.send(buff);
                    res.end();
                })
                    .catch(function (err) {
                    throw err;
                });
            }
            else if (this._options.width && this._options.height) {
                sharp(this.path)
                    .resize(this._options.width, this._options.height)
                    .crop(sharp.gravity.centre)
                    .toBuffer()
                    .then(function (buff) {
                    res.send(buff);
                    res.end();
                })
                    .catch(function (err) {
                    throw err;
                });
            }
            return;
        }
        res.download(this.path);
    };
    return FileResponse;
}(response_1.default));
exports.default = FileResponse;
