"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var currentEntity = initGraphEntity();
function initGraphEntity() {
    return {
        className: "",
        hasGraphQL: false,
        fields: Array()
    };
}
function GraphQL(options) {
    return function (target) {
        currentEntity.hasGraphQL = true;
        if (options && options.name) {
            currentEntity.className = options.name;
        }
        else {
            currentEntity.className = target.name;
        }
        target.graphQL = currentEntity;
        currentEntity = initGraphEntity();
    };
}
exports.GraphQL = GraphQL;
function GraphField(options) {
    return function (target, key) {
        var type = Reflect.getMetadata("design:type", target, key);
        if (type.name == "Array") {
            type = type.elemType + "[]";
        }
        else {
            type = type.name;
        }
        if (options && options.type) {
            type = options.type;
        }
        var writable = true;
        if (options && options.writable) {
            writable = options.writable;
        }
        currentEntity.fields.push({
            name: key,
            type: type,
            writable: writable
        });
    };
}
exports.GraphField = GraphField;
