export declare const errors: {
    root: string;
    key: string;
    messages: {
        wrapArrays: boolean;
    };
    any: {
        unknown: string;
        invalid: string;
        empty: string;
        required: string;
        allowOnly: string;
        default: string;
    };
    alternatives: {
        base: string;
        child: string;
    };
    array: {
        base: string;
        includes: string;
        includesSingle: string;
        includesOne: string;
        includesOneSingle: string;
        includesRequiredUnknowns: string;
        includesRequiredKnowns: string;
        includesRequiredBoth: string;
        excludes: string;
        excludesSingle: string;
        min: string;
        max: string;
        length: string;
        ordered: string;
        orderedLength: string;
        ref: string;
        sparse: string;
        unique: string;
    };
    boolean: {
        base: string;
    };
    binary: {
        base: string;
        min: string;
        max: string;
        length: string;
    };
    date: {
        base: string;
        format: string;
        strict: string;
        min: string;
        max: string;
        isoDate: string;
        timestamp: {
            javascript: string;
            unix: string;
        };
        ref: string;
    };
    function: {
        base: string;
        arity: string;
        minArity: string;
        maxArity: string;
        ref: string;
        class: string;
    };
    lazy: {
        base: string;
        schema: string;
    };
    object: {
        base: string;
        child: string;
        min: string;
        max: string;
        length: string;
        allowUnknown: string;
        with: string;
        without: string;
        missing: string;
        xor: string;
        or: string;
        and: string;
        nand: string;
        assert: string;
        rename: {
            multiple: string;
            override: string;
            regex: {
                multiple: string;
                override: string;
            };
        };
        type: string;
        schema: string;
    };
    number: {
        base: string;
        min: string;
        max: string;
        less: string;
        greater: string;
        float: string;
        integer: string;
        negative: string;
        positive: string;
        precision: string;
        ref: string;
        multiple: string;
    };
    string: {
        base: string;
        min: string;
        max: string;
        length: string;
        alphanum: string;
        token: string;
        regex: {
            base: string;
            name: string;
            invert: {
                base: string;
                name: string;
            };
        };
        email: string;
        uri: string;
        uriRelativeOnly: string;
        uriCustomScheme: string;
        isoDate: string;
        guid: string;
        hex: string;
        base64: string;
        hostname: string;
        normalize: string;
        lowercase: string;
        uppercase: string;
        trim: string;
        creditCard: string;
        ref: string;
        ip: string;
        ipVersion: string;
    };
};
