"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_controller_1 = require("lynx-framework/base.controller");
var decorators_1 = require("lynx-framework/decorators");
var validate_object_1 = require("lynx-framework/validate-object");
var userLib = require("lynx-framework/libs/users");
var user_entity_1 = require("lynx-framework/entities/user.entity");
var verifiers_1 = require("lynx-framework/verifiers");
var index_1 = require("../index");
var AuthController = /** @class */ (function (_super) {
    __extends(AuthController, _super);
    function AuthController() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(AuthController.prototype, "context", {
        get: function () {
            var c = {};
            var original = index_1.default.settings.context;
            for (var key in original) {
                c[key] = original[key];
            }
            return c;
        },
        enumerable: true,
        configurable: true
    });
    AuthController.prototype.getLogin = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                c = this.context;
                return [2 /*return*/, this.render(index_1.default.settings.loginTemplatePath, req, c)];
            });
        });
    };
    AuthController.prototype.postLogin = function (d, req) {
        return __awaiter(this, void 0, void 0, function () {
            var c, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        c = this.context;
                        if (!d.isValid) {
                            c.errors = d.errors;
                            return [2 /*return*/, this.render(index_1.default.settings.loginTemplatePath, req, c)];
                        }
                        return [4 /*yield*/, userLib.performLogin(d.obj.email, d.obj.password)];
                    case 1:
                        user = _a.sent();
                        if (!(user instanceof user_entity_1.default)) {
                            c.loginError = true;
                            return [2 /*return*/, this.render(index_1.default.settings.loginTemplatePath, req, c)];
                        }
                        userLib.createUserSession(req, user);
                        return [2 /*return*/, this.redirect(index_1.default.settings.redirectPath)];
                }
            });
        });
    };
    AuthController.prototype.logout = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                userLib.destroyUserSession(req);
                return [2 /*return*/, this.redirect(index_1.default.settings.redirectPath)];
            });
        });
    };
    AuthController.prototype.forgotPassword = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                c = this.context;
                return [2 /*return*/, this.render(index_1.default.settings.forgotPasswordTemplatePath, req, c)];
            });
        });
    };
    AuthController.prototype.performForgotPassword = function (d, req) {
        return __awaiter(this, void 0, void 0, function () {
            var c, user, newPassword, _a, sent;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        c = this.context;
                        if (!d.isValid) {
                            c.errors = d.errors;
                            return [2 /*return*/, this.render(index_1.default.settings.forgotPasswordTemplatePath, req, c)];
                        }
                        return [4 /*yield*/, user_entity_1.default.findOne({ where: { email: d.obj.email } })];
                    case 1:
                        user = _b.sent();
                        if (!(user instanceof user_entity_1.default)) {
                            c.emailError = true;
                            return [2 /*return*/, this.render(index_1.default.settings.forgotPasswordTemplatePath, req, c)];
                        }
                        newPassword = userLib.generatePassword();
                        _a = user;
                        return [4 /*yield*/, userLib.hashPassword(newPassword)];
                    case 2:
                        _a.password = _b.sent();
                        return [4 /*yield*/, this.sendMail(req, user.email, '{{"auth_subject_forgot_password"|tr}}', index_1.default.settings.mailForgotPasswordTxtPath, index_1.default.settings.mailForgotPasswordHtmlPath, { user: user, password: newPassword })];
                    case 3:
                        sent = _b.sent();
                        if (!sent) {
                            c.sendError = true;
                            return [2 /*return*/, this.render(index_1.default.settings.forgotPasswordTemplatePath, req, c)];
                        }
                        return [4 /*yield*/, user.save()];
                    case 4:
                        _b.sent();
                        c.sendSuccess = true;
                        return [2 /*return*/, this.render(index_1.default.settings.forgotPasswordTemplatePath, req, c)];
                }
            });
        });
    };
    __decorate([
        decorators_1.Verify(verifiers_1.notAuthUser),
        decorators_1.Name("auth_login"),
        decorators_1.GET(index_1.default.settings.loginPath),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], AuthController.prototype, "getLogin", null);
    __decorate([
        decorators_1.Verify(verifiers_1.notAuthUser),
        decorators_1.Name("auth_perform_login"),
        decorators_1.Body("d", index_1.default.settings.loginSchema),
        decorators_1.POST(index_1.default.settings.loginPath),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [validate_object_1.ValidateObject, Object]),
        __metadata("design:returntype", Promise)
    ], AuthController.prototype, "postLogin", null);
    __decorate([
        decorators_1.Name("auth_logout"),
        decorators_1.Verify(verifiers_1.authUser),
        decorators_1.GET(index_1.default.settings.logoutPath),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], AuthController.prototype, "logout", null);
    __decorate([
        decorators_1.Verify(verifiers_1.notAuthUser),
        decorators_1.Name("auth_forgot_password"),
        decorators_1.GET(index_1.default.settings.forgotPasswordPath),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], AuthController.prototype, "forgotPassword", null);
    __decorate([
        decorators_1.Verify(verifiers_1.notAuthUser),
        decorators_1.Name("auth_perform_forgot_password"),
        decorators_1.Body("d", index_1.default.settings.forgotPasswordSchema),
        decorators_1.POST(index_1.default.settings.forgotPasswordPath),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [validate_object_1.ValidateObject, Object]),
        __metadata("design:returntype", Promise)
    ], AuthController.prototype, "performForgotPassword", null);
    AuthController = __decorate([
        decorators_1.Route(index_1.default.settings.controllerPath)
    ], AuthController);
    return AuthController;
}(base_controller_1.BaseController));
exports.default = AuthController;
