"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Joi = require("joi");
var simple_module_1 = require("lynx-framework/simple.module");
var AuthModule = /** @class */ (function (_super) {
    __extends(AuthModule, _super);
    function AuthModule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(AuthModule.prototype, "controllers", {
        get: function () {
            return __dirname + "/controllers";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AuthModule.prototype, "translation", {
        get: function () {
            return __dirname + "/locale";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AuthModule.prototype, "views", {
        get: function () {
            return __dirname + "/views";
        },
        enumerable: true,
        configurable: true
    });
    AuthModule.settings = {
        loginSchema: Joi.object().keys({
            email: Joi.string()
                .email()
                .required()
                .label("{{auth_input_email}}"),
            password: Joi.string()
                .required()
                .min(4)
                .regex(/^[a-zA-Z0-9]{3,30}$/)
                .label("{{auth_input_password}}")
        }),
        forgotPasswordSchema: Joi.object().keys({
            email: Joi.string()
                .email()
                .required()
                .label("{{auth_input_email}}")
        }),
        controllerPath: "/auth",
        loginPath: "/login",
        logoutPath: "/logout",
        forgotPasswordPath: "/forgotPassword",
        loginTemplatePath: "auth/login",
        forgotPasswordTemplatePath: "auth/forgot_password",
        redirectPath: "/",
        mailForgotPasswordHtmlPath: "auth/mails/forgot_password.html",
        mailForgotPasswordTxtPath: "auth/mails/forgot_password.txt",
        context: {
            masterTemplatePath: "./base.njk",
            loginComponentPath: "/auth/login.component"
        }
    };
    return AuthModule;
}(simple_module_1.default));
exports.default = AuthModule;
