"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var typeorm_1 = require("typeorm");
var BaseEntity = /** @class */ (function (_super) {
    __extends(BaseEntity, _super);
    function BaseEntity() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hiddenFields = [];
        return _this;
    }
    BaseEntity.prototype.removeHiddenField = function (field) {
        if (!this.hiddenFields || this.hiddenFields.length == 0) {
            return;
        }
        var index = this.hiddenFields.indexOf(field);
        if (index != -1) {
            this.hiddenFields.splice(index, 1);
        }
    };
    BaseEntity.prototype.addHiddenField = function (field) {
        if (!this.hiddenFields) {
            this.hiddenFields = [];
        }
        var index = this.hiddenFields.indexOf(field);
        if (index != -1) {
            return;
        }
        this.hiddenFields.push(field);
    };
    BaseEntity.prototype.serialize = function () {
        var obj = {};
        for (var key in this) {
            if (key === "hiddenFields") {
                continue;
            }
            if (!this.hiddenFields ||
                (this.hiddenFields && this.hiddenFields.indexOf(key) == -1)) {
                if (this[key] && this[key].serialize) {
                    obj[key] = this[key].serialize();
                }
                else {
                    obj[key] = this[key];
                }
            }
        }
        return obj;
    };
    __decorate([
        typeorm_1.CreateDateColumn(),
        __metadata("design:type", Date)
    ], BaseEntity.prototype, "createdAt", void 0);
    __decorate([
        typeorm_1.UpdateDateColumn(),
        __metadata("design:type", Date)
    ], BaseEntity.prototype, "updatedAt", void 0);
    return BaseEntity;
}(typeorm_1.BaseEntity));
exports.default = BaseEntity;
