"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var response_1 = require("./response");
/**
 * Generate an HTML response using the template engine.
 */
var RenderResponse = /** @class */ (function (_super) {
    __extends(RenderResponse, _super);
    /**
     * The constructor
     * @param view the path to the view
     * @param context the context necessary to generate the template
     */
    function RenderResponse(view, context) {
        var _this = _super.call(this) || this;
        _this.view = view;
        _this.context = context;
        return _this;
    }
    RenderResponse.prototype.performResponse = function (req, res) {
        if (!this.context) {
            this.context = {};
        }
        if (req.lang) {
            this.context.lang = req.lang;
        }
        else {
            this.context.lang = "it";
        }
        res.render(this.view, this.context);
    };
    return RenderResponse;
}(response_1.default));
exports.default = RenderResponse;
